﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace WindowsFormsApplication40
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        DataSet ds;
        private void Form1_Load(object sender, EventArgs e)
        {
            ds = this.CreateData();
            this.ultraGrid1.SetDataBinding(ds, "A");
            this.ultraGrid2.SetDataBinding(ds, "A.AB.BC");
        }

        private DataSet CreateData()
        {
            DataSet ds = new DataSet();
            DataTable dtA = new DataTable();
            dtA.TableName = "A";
            dtA.Columns.Add("Key", typeof(int));
            dtA.Columns.Add("Text", typeof(string));

            DataTable dtB = new DataTable();
            dtB.TableName = "B";
            dtB.Columns.Add("ParentKey", typeof(int));
            dtB.Columns.Add("Key", typeof(int));
            dtB.Columns.Add("Text", typeof(string));

            DataTable dtC = new DataTable();
            dtC.TableName = "C";
            dtC.Columns.Add("ParentKey", typeof(int));
            dtC.Columns.Add("Key", typeof(int));
            dtC.Columns.Add("Text", typeof(string));

            ds.Tables.Add(dtA);
            ds.Tables.Add(dtB);
            ds.Tables.Add(dtC);

            ds.Relations.Add("AB", dtA.Columns["Key"], dtB.Columns["ParentKey"]);
            ds.Relations.Add("BC", dtB.Columns["Key"], dtC.Columns["ParentKey"]);

            int keyA;
            int keyB = 0;
            int keyC;
            for (int i = 100; i < 400; i+= 100)
            {
                keyA = i;
                dtA.Rows.Add(new object[] { keyA, "Parent Row " + i.ToString() });
                for (int j = 10; j < 40; j+= 10)
                {
                    keyB = keyA + j;
                    dtB.Rows.Add(new object[] { keyA, keyB, "Child Row " + i.ToString() + ", " + j.ToString() });
                    for (int k = 1; k < 4; k++)
                    {
                        keyC = keyB + k;
                        dtC.Rows.Add(new object[] { keyB, keyC, "GrandChild Row " + i.ToString() + ", " + j.ToString() + ", " + k.ToString() });
                    }
                }
            }

            return ds;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            foreach (UltraGridBand band in e.Layout.Bands)
            {
                band.HeaderVisible = true;
                band.Header.Appearance.TextHAlign = Infragistics.Win.HAlign.Left;
            }
        }

        private void ultraGrid2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            foreach (UltraGridBand band in e.Layout.Bands)
            {
                band.HeaderVisible = true;
                band.Header.Appearance.TextHAlign = Infragistics.Win.HAlign.Left;
            }
        }
    }
}
